Index: trunk/src/win32k/kKrnlLib/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/Makefile	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/Makefile	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.25 2002-03-31 19:40:12 bird Exp $
+# $Id: Makefile,v 1.26 2002-04-07 22:40:15 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
@@ -22,4 +22,6 @@
 SUBDIRS     = tools include
 PREMAKEFILES= kKrnlLib.mak kKrnlLibR3Tst.mak
+BUILD_NO_TESTCASE = 1
+
 
 
@@ -35,3 +37,10 @@
 
 
+#
+# Our own minimal testcase rule
+#
+testcase:
+!if [$(TOOL_EXISTS) testcase] == 0
+    @$(TOOL_DODIRS) "testcase" $(TOOL_MAKE) $@
+!endif
 
Index: trunk/src/win32k/kKrnlLib/clib16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/clib16.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/clib16.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: clib16.mak,v 1.2 2002-04-01 12:42:46 bird Exp $
+# $Id: clib16.mak,v 1.3 2002-04-07 22:40:15 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !include ..\makefile.inc
 
Index: trunk/src/win32k/kKrnlLib/devhelp16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/devhelp16.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/devhelp16.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: devhelp16.mak,v 1.1 2002-03-10 05:22:32 bird Exp $
+# $Id: devhelp16.mak,v 1.2 2002-04-07 22:40:15 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !include ..\makefile.inc
 
Index: trunk/src/win32k/kKrnlLib/kKrnlLib.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/kKrnlLib.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/kKrnlLib.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: kKrnlLib.mak,v 1.3 2002-04-01 12:43:10 bird Exp $
+# $Id: kKrnlLib.mak,v 1.4 2002-04-07 22:40:16 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
Index: trunk/src/win32k/kKrnlLib/kKrnlLibR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/kKrnlLibR3Tst.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/kKrnlLibR3Tst.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: kKrnlLibR3Tst.mak,v 1.1 2002-03-31 19:30:39 bird Exp $
+# $Id: kKrnlLibR3Tst.mak,v 1.2 2002-04-07 22:40:16 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
@@ -39,5 +39,4 @@
 TARGET_OBJS =\
 $(PATH_OBJ)\kKrnlLib_first.$(EXT_LIB)\kKrnlLib_first.$(EXT_LIB)\
-$(PATH_OBJ)\kKrnlLib_testcase.$(EXT_LIB)\kKrnlLib_testcase.$(EXT_LIB)\
 $(PATH_OBJ)\kKrnlLib_srcR3Tst.$(EXT_LIB)\kKrnlLib_srcR3Tst.$(EXT_LIB)\
 
@@ -66,5 +65,5 @@
 $(PATH_OBJ)\kKrnlLib_last.$(EXT_LIB)\kKrnlLib_last.$(EXT_LIB)
 
-SUBDIRS     = include src kLib testcase
+SUBDIRS     = include src kLib
 
 PREMAKEFILES= clib16.mak devhelp16.mak
Index: trunk/src/win32k/kKrnlLib/kLib.inc
===================================================================
--- trunk/src/win32k/kKrnlLib/kLib.inc	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/kLib.inc	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: kLib.inc,v 1.1 2002-03-31 19:30:40 bird Exp $
+# $Id: kLib.inc,v 1.2 2002-04-07 22:40:16 bird Exp $
 
 #
@@ -24,5 +24,5 @@
 TARGET_MODE     = SYSLIB
 PATH_ROOT       = $(PATH_WIN32K)\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
Index: trunk/src/win32k/kKrnlLib/src/Dev16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Dev16.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/Dev16.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Dev16.mak,v 1.3 2002-03-31 19:01:05 bird Exp $
+# $Id: Dev16.mak,v 1.4 2002-04-07 22:39:43 bird Exp $
 
 #
@@ -14,5 +14,5 @@
 BUILD_ENV  = MSCV6
 PATH_ROOT  = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !include ..\..\makefile.inc
 
Index: trunk/src/win32k/kKrnlLib/src/Dev16R3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Dev16R3Tst.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/Dev16R3Tst.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Dev16R3Tst.mak,v 1.1 2002-03-31 19:30:40 bird Exp $
+# $Id: Dev16R3Tst.mak,v 1.2 2002-04-07 22:39:43 bird Exp $
 
 #
@@ -14,5 +14,5 @@
 BUILD_ENV  = MSCV6
 PATH_ROOT  = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !include ..\..\makefile.inc
 
Index: trunk/src/win32k/kKrnlLib/src/Extract.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Extract.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/Extract.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Extract.mak,v 1.4 2002-03-31 19:01:05 bird Exp $
+# $Id: Extract.mak,v 1.5 2002-04-07 22:39:44 bird Exp $
 
 #
@@ -11,5 +11,5 @@
 !include ..\..\makefile.inc
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 PATH_BIN   = $(PATH_TOOLS)
 
Index: trunk/src/win32k/kKrnlLib/src/Extract16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Extract16.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/Extract16.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Extract16.mak,v 1.3 2002-03-31 19:01:05 bird Exp $
+# $Id: Extract16.mak,v 1.4 2002-04-07 22:39:44 bird Exp $
 
 #
@@ -17,5 +17,5 @@
 BUILD_ENV  = MSCV6
 PATH_ROOT  = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !include ..\..\makefile.inc
 
Index: trunk/src/win32k/kKrnlLib/src/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Makefile	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/Makefile	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.5 2002-04-01 12:45:55 bird Exp $
+# $Id: Makefile,v 1.6 2002-04-07 22:39:43 bird Exp $
 
 #
@@ -10,5 +10,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
@@ -25,7 +25,7 @@
 # Targets.
 #
-PREMAKEFILES = newdbg.mak newrel.mak Dev16.mak
+PREMAKEFILES = MkCallTab.mak newdbg.mak newrel.mak Dev16.mak
 
-POSTMAKEFILES = first.mak last.mak srcR3Tst.mak MkCallTab.mak
+POSTMAKEFILES = first.mak last.mak srcR3Tst.mak
 
 TARGET_OBJS =\
@@ -67,4 +67,7 @@
 $(PATH_ROOT)\obj\$(NAME_1)$(NAME_2)mscv6\kKrnlLib_dev16.$(EXT_LIB)\kKrnlLib_dev16.$(EXT_LIB)\
 
+TARGET_NO_DEP=\
+calltaba.c
+
 
 #
Index: trunk/src/win32k/kKrnlLib/src/MkCallTab.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/MkCallTab.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/MkCallTab.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: MkCallTab.mak,v 1.4 2002-03-31 19:01:06 bird Exp $
+# $Id: MkCallTab.mak,v 1.5 2002-04-07 22:39:45 bird Exp $
 
 #
@@ -14,5 +14,5 @@
 BUILD_ENV  = MSCV6
 PATH_ROOT  = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !include ..\..\makefile.inc
 PATH_BIN   = $(PATH_TOOLS)
Index: trunk/src/win32k/kKrnlLib/src/first.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/first.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/first.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: first.mak,v 1.2 2002-03-31 19:01:16 bird Exp $
+# $Id: first.mak,v 1.3 2002-04-07 22:39:44 bird Exp $
 
 #
@@ -10,5 +10,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
Index: trunk/src/win32k/kKrnlLib/src/last.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/last.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/last.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: last.mak,v 1.2 2002-03-31 19:01:16 bird Exp $
+# $Id: last.mak,v 1.3 2002-04-07 22:39:45 bird Exp $
 
 #
@@ -10,5 +10,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
Index: trunk/src/win32k/kKrnlLib/src/newdbg.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newdbg.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/newdbg.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: newdbg.mak,v 1.2 2002-03-31 19:01:17 bird Exp $
+# $Id: newdbg.mak,v 1.3 2002-04-07 22:39:45 bird Exp $
 
 #
@@ -16,5 +16,5 @@
 ALL_DEFINES = -DKKRNLLIB
 PATH_ROOT   = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
 CXX_FLAGS_SYS = $(CXX_FLAGS_SYS) -Tm+
Index: trunk/src/win32k/kKrnlLib/src/newdbgR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newdbgR3Tst.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/newdbgR3Tst.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: newdbgR3Tst.mak,v 1.1 2002-03-31 19:30:40 bird Exp $
+# $Id: newdbgR3Tst.mak,v 1.2 2002-04-07 22:39:45 bird Exp $
 
 #
@@ -16,5 +16,5 @@
 ALL_DEFINES = -DKKRNLLIB -DR3TST
 PATH_ROOT   = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
 CXX_FLAGS_SYS = $(CXX_FLAGS_SYS) -Tm+
Index: trunk/src/win32k/kKrnlLib/src/newrel.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newrel.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/newrel.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: newrel.mak,v 1.2 2002-03-31 19:01:17 bird Exp $
+# $Id: newrel.mak,v 1.3 2002-04-07 22:39:46 bird Exp $
 
 #
@@ -16,5 +16,5 @@
 ALL_DEFINES = -DKKRNLLIB
 PATH_ROOT   = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
 CXX_FLAGS_SYS = $(CXX_FLAGS_SYS) -Tm-
Index: trunk/src/win32k/kKrnlLib/src/newrelR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newrelR3Tst.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/newrelR3Tst.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: newrelR3Tst.mak,v 1.1 2002-03-31 19:30:40 bird Exp $
+# $Id: newrelR3Tst.mak,v 1.2 2002-04-07 22:39:46 bird Exp $
 
 #
@@ -16,5 +16,5 @@
 ALL_DEFINES = -DKKRNLLIB -DR3TST
 PATH_ROOT   = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
 CXX_FLAGS_SYS = $(CXX_FLAGS_SYS) -Tm-
Index: trunk/src/win32k/kKrnlLib/src/srcR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/srcR3Tst.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/src/srcR3Tst.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: srcR3Tst.mak,v 1.2 2002-04-01 12:49:19 bird Exp $
+# $Id: srcR3Tst.mak,v 1.3 2002-04-07 22:39:46 bird Exp $
 
 #
@@ -10,5 +10,6 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
+!include ..\..\makefile.inc
 
 
@@ -20,4 +21,5 @@
 MAKEFILE     = srcR3Tst.mak
 ALL_INCLUDES = -I../include
+AS_INCLUDES  = -I$(PATH_DDKBASE)\inc
 ALL_DEFINES  = -DKKRNLLIB -DR3TST
 
@@ -52,4 +54,13 @@
 $(PATH_TARGET)\vprintf.$(EXT_OBJ)\
 $(PATH_TARGET)\vsprintf.$(EXT_OBJ)\
+\
+$(PATH_TARGET)\tstDH.$(EXT_OBJ)\
+$(PATH_TARGET)\tstDos.$(EXT_OBJ)\
+$(PATH_TARGET)\tstDosA.$(EXT_OBJ)\
+$(PATH_TARGET)\tstFake.$(EXT_OBJ)\
+$(PATH_TARGET)\tstFakeA.$(EXT_OBJ)\
+$(PATH_TARGET)\tstInit.$(EXT_OBJ)\
+$(PATH_TARGET)\tstkKrnlLib.$(EXT_OBJ)\
+\
 $(PATH_OBJ)\kKrnlLib_newdbgR3Tst.$(EXT_LIB)\kKrnlLib_newdbgR3Tst.$(EXT_LIB)\
 $(PATH_OBJ)\kKrnlLib_newrelR3Tst.$(EXT_LIB)\kKrnlLib_newrelR3Tst.$(EXT_LIB)\
@@ -68,4 +79,8 @@
 
 
+TARGET_NO_DEP=\
+calltaba.c\
+TstFakers.c
+
 
 #
@@ -74,6 +89,7 @@
 !include $(MAKE_INCLUDE_PROCESS)
 
+
 # generated code.
-TstFakers.c:
+TstFakers.c: .force
     $(TOOL_DOMAKES) "MkCallTab.mak" $(TOOL_MAKE) $@
 
Index: trunk/src/win32k/kKrnlLib/testcase/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/testcase/Makefile	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/testcase/Makefile	(revision 8212)
@@ -1,7 +1,9 @@
-# $Id: Makefile,v 1.1 2002-03-31 19:30:41 bird Exp $
+# $Id: Makefile,v 1.2 2002-04-07 22:37:23 bird Exp $
 
 #
 # kKrnlLib/testcase makefile.
 #
+# Test makefile is setup to automatically execute all testcases
+# for the kKrnlLib.sys driver.
 #
 
@@ -11,33 +13,17 @@
 !include ..\..\Makefile.inc
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
 #
-# Config.
+# Macros
 #
-TARGET_MODE  = SYSLIB
-TARGET_NAME  = kKrnlLib_testcase
-ALL_INCLUDES = -I../include
-AS_INCLUDES  = -I$(PATH_DDKBASE)\inc
-ALL_DEFINES  = -DKKRNLLIB -DR3TST
+KKRNLLIBR3TST = $(PATH_OBJ)\kKrnlLibR3Tst.exe\kKrnlLibR3Tst.exe
 
+testcase: \
+    Kernel-Identifications \
 
-#
-# Targets.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\tstDH.$(EXT_OBJ)\
-$(PATH_TARGET)\tstDos.$(EXT_OBJ)\
-$(PATH_TARGET)\tstDosA.$(EXT_OBJ)\
-$(PATH_TARGET)\tstFake.$(EXT_OBJ)\
-$(PATH_TARGET)\tstFakeA.$(EXT_OBJ)\
-$(PATH_TARGET)\tstInit.$(EXT_OBJ)\
-$(PATH_TARGET)\tstkKrnlLib.$(EXT_OBJ)\
-
-
-#
-# Load the build process rules.
-#
-!include $(MAKE_INCLUDE_PROCESS)
-
+Kernel-Identifications:
+    @$(ECHO) $(CLRFIL)kKrnlLib.sys $(CLRTXT)- Testcase 1: Massive kernel idenfication test.$(CLRRST)
+    if exist h:\kernels\syms\14040R4.sym ..\tools\TestKernels.cmd $(KKRNLLIBR3TST) h:\kernels\syms
+    @$(ECHO) $(CLRFIL)kKrnlLib.sys $(CLRTXT)- Testcase 1: Completed.$(CLRRST)
Index: trunk/src/win32k/kKrnlLib/tools/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/tools/Makefile	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/tools/Makefile	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.1 2002-03-10 04:57:19 bird Exp $
+# $Id: Makefile,v 1.2 2002-04-07 22:40:16 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
Index: trunk/src/win32k/kKrnlLib/tools/ignore.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/tools/ignore.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/tools/ignore.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: ignore.mak,v 1.1 2002-03-10 04:57:07 bird Exp $
+# $Id: ignore.mak,v 1.2 2002-04-07 22:40:16 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 
Index: trunk/src/win32k/kKrnlLib/tools/libconv.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/tools/libconv.mak	(revision 8211)
+++ trunk/src/win32k/kKrnlLib/tools/libconv.mak	(revision 8212)
@@ -1,3 +1,3 @@
-# $Id: libconv.mak,v 1.1 2002-03-10 04:57:08 bird Exp $
+# $Id: libconv.mak,v 1.2 2002-04-07 22:40:16 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\tools\make\setup.mak
+!include $(PATH_ROOT)\make\setup.mak
 
 