Index: trunk/src/kernel32/KERNEL32.DEF
===================================================================
--- trunk/src/kernel32/KERNEL32.DEF	(revision 8594)
+++ trunk/src/kernel32/KERNEL32.DEF	(revision 8600)
@@ -1,3 +1,3 @@
-; $Id: KERNEL32.DEF,v 1.137 2002-05-17 10:14:07 sandervl Exp $
+; $Id: KERNEL32.DEF,v 1.138 2002-06-08 11:40:13 sandervl Exp $
 
 ;Basis is Windows95 KERNEL32
@@ -1215,4 +1215,6 @@
     cp_get_table                                                  @2025 NONAME
 
+    OSLibDosDevIOCtl                                              @2026 NONAME
+
     GetDisplayCodepage                                            @3000 NONAME
     GetWindowsCodepage                                            @3001 NONAME
Index: trunk/src/kernel32/hmdisk.cpp
===================================================================
--- trunk/src/kernel32/hmdisk.cpp	(revision 8594)
+++ trunk/src/kernel32/hmdisk.cpp	(revision 8600)
@@ -1,3 +1,3 @@
-/* $Id: hmdisk.cpp,v 1.46 2002-06-06 11:31:12 sandervl Exp $ */
+/* $Id: hmdisk.cpp,v 1.47 2002-06-08 11:40:14 sandervl Exp $ */
 
 /*
@@ -20,5 +20,5 @@
 #include <win\winioctl.h>
 #include <win\ntddscsi.h>
-#include <win\aspi.h>
+#include <win\wnaspi32.h>
 #include "oslibdos.h"
 #include "osliblvm.h"
@@ -36,4 +36,5 @@
 //Converts BCD to decimal; doesn't check for illegal BCD nrs
 #define BCDToDec(a) ((a >> 4) * 10 + (a & 0xF))
+
 
 typedef struct
@@ -1471,4 +1472,8 @@
             cdiocmd.flDirection = CMDDIR_OUTPUT|CMDDIR_INPUT;;
             break;
+        default:
+            dprintf(("Invalid DataIn (%d)!!", pPacket->DataIn));
+            SetLastError(ERROR_INVALID_PARAMETER);
+            return FALSE;
         }
 
Index: trunk/src/kernel32/kernel32dbg.def
===================================================================
--- trunk/src/kernel32/kernel32dbg.def	(revision 8594)
+++ trunk/src/kernel32/kernel32dbg.def	(revision 8600)
@@ -1,3 +1,3 @@
-; $Id: kernel32dbg.def,v 1.13 2002-05-17 10:14:07 sandervl Exp $
+; $Id: kernel32dbg.def,v 1.14 2002-06-08 11:40:14 sandervl Exp $
 
 ;Basis is Windows95 KERNEL32
@@ -1215,4 +1215,6 @@
     cp_get_table                                                  @2025 NONAME
 
+    OSLibDosDevIOCtl                                              @2026 NONAME
+
     GetDisplayCodepage                                            @3000 NONAME
     GetWindowsCodepage                                            @3001 NONAME
Index: trunk/src/kernel32/oslibcdio.cpp
===================================================================
--- trunk/src/kernel32/oslibcdio.cpp	(revision 8594)
+++ trunk/src/kernel32/oslibcdio.cpp	(revision 8600)
@@ -29,7 +29,7 @@
 
 //needed for high memory support check
-DWORD OSLibDosDevIOCtl( DWORD hFile, DWORD dwCat, DWORD dwFunc,
-                        PVOID pParm, DWORD dwParmMaxLen, DWORD *pdwParmLen,
-                        PVOID pData, DWORD dwDataMaxLen, DWORD *pdwDataLen);
+DWORD SYSTEM OSLibDosDevIOCtl( DWORD hFile, DWORD dwCat, DWORD dwFunc,
+                               PVOID pParm, DWORD dwParmMaxLen, DWORD *pdwParmLen,
+                               PVOID pData, DWORD dwDataMaxLen, DWORD *pdwDataLen);
 
 
Index: trunk/src/kernel32/oslibdos.cpp
===================================================================
--- trunk/src/kernel32/oslibdos.cpp	(revision 8594)
+++ trunk/src/kernel32/oslibdos.cpp	(revision 8600)
@@ -1,3 +1,3 @@
-/* $Id: oslibdos.cpp,v 1.103 2002-06-06 15:10:06 sandervl Exp $ */
+/* $Id: oslibdos.cpp,v 1.104 2002-06-08 11:40:15 sandervl Exp $ */
 /*
  * Wrappers for OS/2 Dos* API
@@ -2978,7 +2978,7 @@
 //******************************************************************************
 //******************************************************************************
-DWORD OSLibDosDevIOCtl( DWORD hFile, DWORD dwCat, DWORD dwFunc,
-                        PVOID pParm, DWORD dwParmMaxLen, DWORD *pdwParmLen,
-                        PVOID pData, DWORD dwDataMaxLen, DWORD *pdwDataLen)
+DWORD SYSTEM OSLibDosDevIOCtl( DWORD hFile, DWORD dwCat, DWORD dwFunc,
+                               PVOID pParm, DWORD dwParmMaxLen, DWORD *pdwParmLen,
+                               PVOID pData, DWORD dwDataMaxLen, DWORD *pdwDataLen)
 {
   APIRET rc;
Index: trunk/src/kernel32/oslibdos.h
===================================================================
--- trunk/src/kernel32/oslibdos.h	(revision 8594)
+++ trunk/src/kernel32/oslibdos.h	(revision 8600)
@@ -1,3 +1,3 @@
-/* $Id: oslibdos.h,v 1.45 2002-05-09 13:55:34 sandervl Exp $ */
+/* $Id: oslibdos.h,v 1.46 2002-06-08 11:40:15 sandervl Exp $ */
 
 /*
@@ -238,7 +238,7 @@
 #endif
 
-DWORD OSLibDosDevIOCtl( DWORD hFile, DWORD dwCat, DWORD dwFunc,
-                        PVOID pParm, DWORD dwParmMaxLen, DWORD *pdwParmLen,
-                        PVOID pData, DWORD dwDataMaxLen, DWORD *pdwDataLen);
+DWORD SYSTEM OSLibDosDevIOCtl( DWORD hFile, DWORD dwCat, DWORD dwFunc,
+                               PVOID pParm, DWORD dwParmMaxLen, DWORD *pdwParmLen,
+                               PVOID pData, DWORD dwDataMaxLen, DWORD *pdwDataLen);
 
 BOOL OSLibGetDiskFreeSpace(LPSTR lpRootPathName, LPDWORD lpSectorsPerCluster,